/*
* Автор: Маркелов С.В.
* Дата: 2014-07-16
* Задача: http://jira.softage.ru/jira/browse/SDFO-332
* Назначение: Заполнение FM1_REVISION
* Изменяются объекты:
		insert into FM1_REVISION
*/

/*
  ****** Инструкции для SQLPlus (обязательно) ******
  Для печати сообщений:
  DBMS_OUTPUT.put_line('<Message>');
*/
whenever sqlerror exit 1;
set serveroutput on;
set echo off;

declare
	filename      varchar2(256) := 'sfm.database-update.2014-07-16.FillFM1_REVISION.sql';
	purpose       varchar2(4000) := 'Заполнение FM1_REVISION';
	script_exists number := 0;
begin

	--delete from DB_Update_History where script_name = filename;	commit;
	select count(*)
		into script_exists
		from DB_Update_History
	 where script_name = filename;

	if (script_exists > 0) then
		RAISE_APPLICATION_ERROR(-20001, '"' || filename || '" уже присутствует в базе');
	else
		insert into DB_Update_History
			(script_name, purpose)
		values
			(filename, purpose);
	end if;

	insert into FM1_REVISION(FM1_REVISION_GUID, FM1_VERSION, START_DATE, END_DATE)
	select replace(VERSIONCODE, '-'), VERSIONID, BEGINDATE, ENDDATE
	from MESSAGES_VERSIONS
	where MESS_TYPE = 1;

	-- Статусы сообщений
	insert into FM1_REV_ANALYTICTYPES(FM1_REVISION_GUID, ANALYTICTYPE)
	select FM1_REVISION_GUID, 21010
	from FM1_REVISION;

	commit;

exception
	when others then
		rollback;
		raise;
end;

/


	/*
	****** Begin update script ******
	*/
		-- Не транзакционный апдейт
		-- Необходимы свои транзакции, если требуются
	/*
	****** End update script ******
	*/
